"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ConfigModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigModule = void 0;
const uuid_1 = require("uuid");
const common_1 = require("@nestjs/common");
const config_service_1 = require("./config.service");
const constants_1 = require("./constants");
let ConfigModule = ConfigModule_1 = class ConfigModule {
    static forRoot({ global, ...options }) {
        const providers = this.createConfigProvidersForRoot(options);
        return {
            global: global ?? true,
            module: ConfigModule_1,
            providers,
            exports: providers.map(({ provide }) => provide)
        };
    }
    static forFeature(options) {
        const providers = this.createConfigProvidersForFeature(options);
        return {
            module: ConfigModule_1,
            providers,
            exports: providers.map(({ provide }) => provide)
        };
    }
    static createConfigProvidersForRoot({ provides, ...options }) {
        return [
            {
                provide: constants_1.GLOBAL_CONFIG_SERVICE_TOKEN,
                useValue: new config_service_1.ConfigService(provides, options)
            },
            {
                provide: config_service_1.ConfigService,
                useFactory: (service) => service,
                inject: [constants_1.GLOBAL_CONFIG_SERVICE_TOKEN]
            }
        ];
    }
    static createConfigProvidersForFeature({ provides: config, ...options }) {
        const configMapToken = (0, uuid_1.v4)();
        return [
            {
                provide: configMapToken,
                useFactory: (parent) => new config_service_1.ConfigService(config, { parent, ...options }),
                inject: [
                    {
                        optional: true,
                        token: constants_1.GLOBAL_CONFIG_SERVICE_TOKEN
                    }
                ]
            },
            {
                provide: config_service_1.ConfigService,
                useFactory: (service) => service,
                inject: [configMapToken]
            }
        ];
    }
};
exports.ConfigModule = ConfigModule;
exports.ConfigModule = ConfigModule = ConfigModule_1 = __decorate([
    (0, common_1.Module)({})
], ConfigModule);
//# sourceMappingURL=config.module.js.map